from sys import setrecursionlimit
import threading

setrecursionlimit(10 ** 9)
threading.stack_size(67108864)



def solve(s, pos):
    # print(f"[{s}]Entered to function. s = {s}; pos = {pos}")
    global ans, A, n
    if len(s) == n:
        ans += 1
        # print(f"[{s}][+] ANSWER")
        return
    for num in A:
        # if s == '2':
        #     print(f"[INFO] s={s}; pos = {pos}; num = {num} ")
        if pos[num] is not None and abs(pos[num] - len(s)) < num:
            # print(f"[{s}]\t[-] num = {num}")
            return
        _pos = pos.copy()
        _pos[num] = len(s)
        # print(f"[{s}]Started new with s = {s + str(num)}; pos = {_pos}")
        solve(s + str(num), _pos)


def main():
    global n, A, ans
    n, m = map(int, input().split())
    A = list(map(int, input().split()))
    ans = 0
    for num in A:
        pos = [None for _ in range(n)]
        pos[num] = 0
        solve(str(num), pos)
    print(ans)


if __name__ == '__main__':
    thread = threading.Thread(target=main)
    thread.start()
